#include<bits/stdc++.h>
#define MAXN 100000
using namespace std;
int n,q,p[MAXN],dp[MAXN];
vector<int> a[MAXN];
int dfs(int x){
    int ans=0;
    for(int i=0;i<a[x].size();i++){
        if(a[x][i]==p[x]) continue;
        ans+=dfs(a[x][i])+1;
    }
    dp[x]=ans;
    return dp[x];
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    for(int i=0;i<n-1;i++){
        int x,y;
        cin>>x>>y;
        p[y]=x;
        a[x].push_back(y);
    }
    int k;
    for(int i=1;i<=n;i++){
        if(p[i]==0){
            k=i;
            break;
        }
    }
    dfs(k);
    cin>>q;
    for(int i=0;i<q;i++){
        int x;
        cin>>x;
        cout<<dp[x]<<"\n";
    }
    return 0;
}

